// Generated by CoffeeScript 1.6.2
var NodeBindingFactory, allBindingClasses, bdble, classes, clazz, dataBind, defaultBindingClasses, nodeFactory, type, _i, _len;

bdble = require("bindable");

allBindingClasses = {
  node: {},
  attr: {
    "default": []
  }
};

NodeBindingFactory = (function() {
  function NodeBindingFactory() {}

  /*
  */


  NodeBindingFactory.prototype.getBindings = function(options) {
    var attrName, attributes, bindable, bindables, bindingClass, bindingClasses, bindings, context, node, nodeName, _i, _j, _len, _len1;

    bindings = [];
    attributes = options.attributes;
    nodeName = options.nodeName;
    node = options.node;
    bindables = [
      {
        name: nodeName,
        key: nodeName,
        value: node,
        type: "node",
        node: node
      }, {
        name: nodeName,
        key: "default",
        value: node,
        type: "node",
        node: node
      }
    ];
    context = void 0;
    for (attrName in attributes) {
      bindables.push({
        node: node,
        name: attrName,
        key: attrName,
        value: attributes[attrName],
        type: "attr"
      });
      bindables.push({
        node: node,
        name: attrName,
        key: "default",
        value: attributes[attrName],
        type: "attr"
      });
    }
    for (_i = 0, _len = bindables.length; _i < _len; _i++) {
      bindable = bindables[_i];
      bindingClasses = allBindingClasses[bindable.type][bindable.key] || [];
      for (_j = 0, _len1 = bindingClasses.length; _j < _len1; _j++) {
        bindingClass = bindingClasses[_j];
        if (bindingClass.prototype.test(bindable)) {
          if (!context) {
            context = new bdble.Object();
          }
          bindable.context = context;
          bindings.push(new bindingClass(bindable));
        }
      }
    }
    return bindings;
  };

  /*
  */


  NodeBindingFactory.prototype.register = function(name, bindingClass) {
    var classes, type;

    type = bindingClass.type || bindingClass.prototype.type;
    if (!/node|attr/.test(String(type))) {
      throw new Error("node binding class \"" + bindingClass.name + "\" must have a type 'node', or 'attr'");
    }
    classes = allBindingClasses[type];
    if (!bindingClass.prototype.test) {
      bindingClass.prototype.test = function() {
        return true;
      };
    }
    if (!classes[name]) {
      classes[name] = [];
    }
    classes[name].push(bindingClass);
    return this;
  };

  return NodeBindingFactory;

})();

nodeFactory = module.exports = new NodeBindingFactory();

defaultBindingClasses = {
  "default": [require("./attrs/text")],
  "data-bind": [dataBind = module.exports.dataBind = require("./attrs/dataBind")]
};

for (type in defaultBindingClasses) {
  classes = defaultBindingClasses[type];
  for (_i = 0, _len = classes.length; _i < _len; _i++) {
    clazz = classes[_i];
    nodeFactory.register(type, clazz);
  }
}
